searchNodes=[{"ref":"Rexbug.html","title":"Rexbug","type":"module","doc":"A thin Elixir wrapper for the redbug Erlang tracing debugger."},{"ref":"Rexbug.html#help/0","title":"Rexbug.help/0","type":"function","doc":"Prints the help message / usage manual to standard output. The help message is as follows: Rexbug - a thin Elixir wrapper for :redbug - the (sensibly) Restrictive Debugger. It doesn&#39;t fork :redbug, only uses it under the hood. You can use :redbug directly - run :redbug.help() to see its help message. Inner workings: Rexbug is a tool to interact with the Erlang trace facility. It will instruct the Erlang VM to generate so called &quot;trace messages&quot; when certain events (such as a particular function being called) occur. The trace messages are either printed (i.e. human readable) to a file or to the screen; or written to a trc file. Using a trc file puts less stress on the system, but there is no way to count the messages (so the msgs opt is ignored), and the files can only be read by special tools (such as &#39;bread&#39;). Printing and trc files cannot be combined. By default (i.e. if the :file opt is not given), messages are printed. Basic usage: Rexbug.start(trace_pattern, opts \\ []) Rexbug.start(time_limit, message_limit, trace_pattern) trace_pattern: :send | :receive | rtp | [:send | :receive | rtp] rtp: restricted trace pattern the rtp has the form: &quot;&lt;mfa&gt; when &lt;guards&gt; :: &lt;actions&gt;&quot; where &lt;mfa&gt; can be: &quot;Mod&quot;, &quot;Mod.fun/3&quot;, &quot;Mod.fun/_&quot; or &quot;Mod.fun(_, :atom, x)&quot; &lt;guard&gt; is something like: &quot;x==1&quot; or &quot;is_atom(a)&quot; and &lt;actions&gt; is: &quot;&quot;, &quot;return&quot;, &quot;stack&quot;, or &quot;return;stack&quot; E.g. :ets.lookup(t, :hostname) when is_integer(t) :: stack Map.new/2 Map.pop(_, :some_key, default) when default != nil :: return Agent NOTE: The &lt;mfa&gt; of &quot;Map.new&quot; is equivalent to &quot;Map.new()&quot; - the 0 arity is implied. To trace the function with any arity use &quot;Map.new/any&quot; or simply &quot;Map.new/_&quot;. opts: Keyword.t general opts (and their default values): time (15_000) stop trace after this many ms msgs (10) stop trace after this many msgs target (Node.self()) node to trace on cookie (host cookie) target node cookie blocking (false) block start/2, return a list of messages arity (false) print arity instead of arg list buffered (false) buffer messages till end of trace discard (false) discard messages (when counting) max_queue (5_000) fail if internal queue gets this long max_msg_size (50_000) fail if seeing a msg this big procs (:all) (list of) Erlang process(es) :all|:new|pid()|atom(reg_name)|{:pid,i2,i3} print-related opts: print_calls (true) print calls print_file (standard_io) print to this file print_msec (false) print milliseconds on timestamps print_depth (999_999) formatting depth for &quot;~P&quot; print_re (&quot;&quot;) print only messages that match this regex print_return (true) print return value (if &quot;return&quot; action given) print_fun () custom print handler, fun/1 or fun/2; fun(trace_msg :: term) :: &lt;ignored&gt; fun(trace_msg, acc_old) :: acc_new (where initial accumulator is 0) trc file related opts: file (none) use a trc file based on this name file_size (1) size of each trc file file_count (8) number of trc files"},{"ref":"Rexbug.html#start/1","title":"Rexbug.start/1","type":"function","doc":"See Rexbug.start/2."},{"ref":"Rexbug.html#start/2","title":"Rexbug.start/2","type":"function","doc":"Starts tracing for the given pattern with provided options. If successful and :blocking option is not specified, returns a tuple where the first element is the count of targeted processes and the second element is the count of targeted functions Trace Pattern The trace_pattern is a string (binary) describing which function(s) should be traced. The trace_pattern has the &quot;&lt;mfa&gt; when &lt;guards&gt; :: &lt;actions&gt;&quot; form, where guards and actions are optional and &lt;mfa&gt; can be in the form of Mod, Mod.fun/3, Mod.fun/_ or Mod.fun(_, :atom, x) Most normal Elixir guards are valid as &lt;guards&gt;, so something like x==1 or is_atom(x) or is_integer(i) and i &gt; 0 would work. The valid &lt;actions&gt; are: return, stack, or return;stack Apart from tracing function calls you can trace sent and received messages. To do so specify :send or :receive as the trace pattern. You can also specify multiple trace patterns by providing a list of them as the first argument. Options There&#39;s a range of options that modify the behaviour of Rexbug. General options optiondefault&nbsp;valuemeaning time15_000stop tracing after this many milliseconds msgs10stop tracing after this many messages targetNode.self()node to trace on cookiehost cookietarget node cookie blockingfalseblock on start/2 and return a list of messages. see comment arityfalseprint arity instead of argument list bufferedfalsebuffer messages till end of trace discardfalsediscard messages (when counting) max_queue5_000fail if internal queue gets this long max_msg_size50_000fail if seeing a message this big procs:all(list of) Erlang process(es) to include when tracing. see comment Print-related options optiondefault&nbsp;valuemeaning print_callstrueprint calls print_filestandard_ioif provided, prints messages to the specified file print_msecfalseprint milliseconds on timestamps print_depth999_999formatting depth for &quot;~P&quot; print_re&quot;&quot;print only messages that match this regex print_returntrueif set to false, won&#39;t print the return values. Relevant only if return action is specified print_funnoneCustom print handler. see comment Trace file related options optiondefault&nbsp;valuemeaning filenoneuse a trc file based on this name file_size1size of each trc file file_count8number of trc files Options comments :blocking If set to true, instead of printing traces to stdio, Rexbug.start/2 will block and return a list of trace messages when it&#39;s done tracing. :procs Which processes to trace. The possible values are :all for all processes, :new for just the ones spawned after the tracing has started, an atom for registered processes, or a pid. The pid can either be a PID literal or a {:pid, x, y}, where x and y are the latter 2 integers from the PID representation. So for example #PID&lt;0.150.0&gt; could be expressed with {:pid, 150, 0}. The first integer from the PID representation is omitted, because it represents the node number. You can use the target option to specify a remote node instead. You can provide either a single process or a list of procs to trace. :print_fun Custom function to use to print the trace messages. The function can be in the fun(trace_msg :: term) :: &lt;ignored&gt; format or the fun(trace_msg, acc_old) :: acc_new format. If you use the latter format, the initial accumulator will be 0."},{"ref":"Rexbug.html#start/3","title":"Rexbug.start/3","type":"function","doc":"See Rexbug.start/2."},{"ref":"Rexbug.html#start/4","title":"Rexbug.start/4","type":"function","doc":"See Rexbug.start/2."},{"ref":"Rexbug.html#start/5","title":"Rexbug.start/5","type":"function","doc":"See Rexbug.start/2."},{"ref":"Rexbug.html#stop/0","title":"Rexbug.stop/0","type":"function","doc":"Stops all tracing."},{"ref":"Rexbug.html#stop_sync/1","title":"Rexbug.stop_sync/1","type":"function","doc":"Stops all tracing in a synchronous manner. Usually there&#39;s no need to use this function over stop/0. You might want to use it if you&#39;re going to start tracing immediately afterwards in an automated fashion."},{"ref":"Rexbug.html#t:proc/0","title":"Rexbug.proc/0","type":"type","doc":""},{"ref":"Rexbug.html#t:procs/0","title":"Rexbug.procs/0","type":"type","doc":""},{"ref":"Rexbug.html#t:redbug_blocking_return/0","title":"Rexbug.redbug_blocking_return/0","type":"type","doc":""},{"ref":"Rexbug.html#t:redbug_error/0","title":"Rexbug.redbug_error/0","type":"type","doc":""},{"ref":"Rexbug.html#t:redbug_non_blocking_return/0","title":"Rexbug.redbug_non_blocking_return/0","type":"type","doc":""},{"ref":"Rexbug.html#t:rexbug_error/0","title":"Rexbug.rexbug_error/0","type":"type","doc":""},{"ref":"Rexbug.html#t:rexbug_return/0","title":"Rexbug.rexbug_return/0","type":"type","doc":""},{"ref":"Rexbug.html#t:trace_pattern/0","title":"Rexbug.trace_pattern/0","type":"type","doc":""},{"ref":"Rexbug.html#t:trace_pattern_instance/0","title":"Rexbug.trace_pattern_instance/0","type":"type","doc":""},{"ref":"Rexbug.Printing.html","title":"Rexbug.Printing","type":"module","doc":"Provides the print handler and helper functions for writing custom print handlers for Rexbug. You shouldn&#39;t need to use it directly unless you want to implement a print handler yourself. See Rexbug.start/2 print_fun option for details."},{"ref":"Rexbug.Printing.html#extract_stack/1","title":"Rexbug.Printing.extract_stack/1","type":"function","doc":"Extracts the call stack from Rexbug.Printing.Call.t/0 dump field. NOTE: The dump field will contain call stack information only if you specify &quot; :: stack&quot; in Rexbug.start/2&#39;s trace pattern, it will be nil or empty otherwise."},{"ref":"Rexbug.Printing.html#from_erl/1","title":"Rexbug.Printing.from_erl/1","type":"function","doc":"Translates the :redbug tuples representing the tracing messages to Elixir structs. You can use it to implement your own custom print_fun."},{"ref":"Rexbug.Printing.html#print/1","title":"Rexbug.Printing.print/1","type":"function","doc":"The default value for the Rexbug.start/2 print_fun option. Prints out the tracing messages generated by :redbug in a nice Elixir format."},{"ref":"Rexbug.Printing.Call.html","title":"Rexbug.Printing.Call","type":"module","doc":""},{"ref":"Rexbug.Printing.Call.html#represent/2","title":"Rexbug.Printing.Call.represent/2","type":"function","doc":""},{"ref":"Rexbug.Printing.Call.html#t:t/0","title":"Rexbug.Printing.Call.t/0","type":"type","doc":""},{"ref":"Rexbug.Printing.MFA.html","title":"Rexbug.Printing.MFA","type":"module","doc":""},{"ref":"Rexbug.Printing.MFA.html#from_erl/1","title":"Rexbug.Printing.MFA.from_erl/1","type":"function","doc":""},{"ref":"Rexbug.Printing.MFA.html#represent/2","title":"Rexbug.Printing.MFA.represent/2","type":"function","doc":""},{"ref":"Rexbug.Printing.MFA.html#t:t/0","title":"Rexbug.Printing.MFA.t/0","type":"type","doc":""},{"ref":"Rexbug.Printing.Receive.html","title":"Rexbug.Printing.Receive","type":"module","doc":""},{"ref":"Rexbug.Printing.Receive.html#represent/2","title":"Rexbug.Printing.Receive.represent/2","type":"function","doc":""},{"ref":"Rexbug.Printing.Receive.html#t:t/0","title":"Rexbug.Printing.Receive.t/0","type":"type","doc":""},{"ref":"Rexbug.Printing.Return.html","title":"Rexbug.Printing.Return","type":"module","doc":""},{"ref":"Rexbug.Printing.Return.html#represent/2","title":"Rexbug.Printing.Return.represent/2","type":"function","doc":""},{"ref":"Rexbug.Printing.Return.html#t:t/0","title":"Rexbug.Printing.Return.t/0","type":"type","doc":""},{"ref":"Rexbug.Printing.Send.html","title":"Rexbug.Printing.Send","type":"module","doc":""},{"ref":"Rexbug.Printing.Send.html#represent/2","title":"Rexbug.Printing.Send.represent/2","type":"function","doc":""},{"ref":"Rexbug.Printing.Send.html#t:t/0","title":"Rexbug.Printing.Send.t/0","type":"type","doc":""},{"ref":"Rexbug.Printing.Timestamp.html","title":"Rexbug.Printing.Timestamp","type":"module","doc":""},{"ref":"Rexbug.Printing.Timestamp.html#from_erl/1","title":"Rexbug.Printing.Timestamp.from_erl/1","type":"function","doc":""},{"ref":"Rexbug.Printing.Timestamp.html#represent/2","title":"Rexbug.Printing.Timestamp.represent/2","type":"function","doc":""},{"ref":"Rexbug.Printing.Timestamp.html#t:t/0","title":"Rexbug.Printing.Timestamp.t/0","type":"type","doc":""},{"ref":"Rexbug.Translator.html","title":"Rexbug.Translator","type":"module","doc":"Utility module for translating Elixir syntax to the one expected by :redbug. You probably don&#39;t need to use it directly."},{"ref":"Rexbug.Translator.html#translate/1","title":"Rexbug.Translator.translate/1","type":"function","doc":"Translates the Elixir trace pattern(s) (understood by Rexbug) to the Erlang trace pattern charlist(s) understood by :redbug. The translated version is not necessarily the cleanest possible, but should be correct and functionally equivalent. Example iex&gt; import Rexbug.Translator iex&gt; translate(&quot;:cowboy.start_clear/3&quot;) {:ok, &#39;\\&#39;cowboy\\&#39;:\\&#39;start_clear\\&#39;/3&#39;} iex&gt; translate(&quot;MyModule.do_sth(_, [pretty: true])&quot;) {:ok, &#39;\\&#39;Elixir.MyModule\\&#39;:\\&#39;do_sth\\&#39;(_, [{\\&#39;pretty\\&#39;, true}])&#39;}"},{"ref":"Rexbug.Translator.html#translate_options/1","title":"Rexbug.Translator.translate_options/1","type":"function","doc":"Translates the options to be passed to Rexbug.start/2 to the format expected by :redbug Relevant values passed as strings will be converted to charlists."},{"ref":"readme.html","title":"README","type":"extras","doc":"Rexbug is a thin Elixir wrapper for :redbug production-friendly Erlang tracing debugger. It tries to preserve :redbug&#39;s simple and intuitive interface while making it more convenient to use by Elixir developers. README"},{"ref":"readme.html#what-does-it-do","title":"README - What does it do?","type":"extras","doc":"It&#39;s an Elixir tracing - based debugger. It allows you to connect to a live Elixir system and get information when some code inside it is executed. The &quot;some code&quot; can be a whole module, a specific function in the module, or some function, but only if it&#39;s called with some specific arguments. The information you can get is the function arguments, its result and the stack trace. If you want to you can narrow the tracing down to a specific process, investigate a remote node or look at the messages sent between processes. Rexbug is also production-system-friendly. It has sensible limits for both time and amount of trace events after which it stops tracing. This means you won&#39;t accidentally overload the system and flood your console with debug information if your trace pattern wasn&#39;t specific enough."},{"ref":"readme.html#how-does-it-work","title":"README - How does it work?","type":"extras","doc":"Rexbug uses unmodified :redbug library underneath. It translates Elixir syntax to the Erlang format expected by :redbug. :redbug in turn interacts with the Erlang trace facility. It will instruct the Erlang VM to generate so called &quot;trace messages&quot; when certain events (such as a particular function being called) occur. The trace messages are either printed (i.e. human readable) to a file or to the screen; or written to a trc file. Using a trc file puts less stress on the system, but there is no way to count the messages (so the msgs opt is ignored), and the files can only be read by special tools (such as &#39;bread&#39;). Printing and trc files cannot be combined. By default (i.e. if the :file opt is not given), messages are printed."},{"ref":"readme.html#installation","title":"README - Installation","type":"extras","doc":"The package can be installed by adding Rexbug to your list of dependencies in mix.exs: def deps do [{:rexbug, &quot;&gt;= 1.0.0&quot;}] end After you&#39;ve added Rexbug to your project, there&#39;s nothing left to do - you can start debugging it at your convenience."},{"ref":"readme.html#examples","title":"README - Examples","type":"extras","doc":"Tracing a whole module iex&gt; Rexbug.start(&quot;Map&quot;) {82, 41} iex&gt; m = Map.put(%{}, :foo, :bar) # this could have been called in any process %{foo: :bar} # 18:51:55 #PID&lt;0.150.0&gt; IEx.Evaluator.init/4 # Map.__info__(:macros) iex&gt; Map.get(m, :foo) :bar # 18:51:57 #PID&lt;0.150.0&gt; IEx.Evaluator.init/4 # Map.__info__(:macros) # 18:51:57 #PID&lt;0.150.0&gt; IEx.Evaluator.init/4 # Map.get(%{foo: :bar}, :foo) # 18:51:57 #PID&lt;0.150.0&gt; IEx.Evaluator.init/4 # Map.get(%{foo: :bar}, :foo, nil) iex&gt; # Rexbug tracing is going to time out now nil redbug done, timeout - 4 iex&gt; Tracing with matching function arguments iex&gt; Rexbug.start(&quot;Enum.member?([_, _, _], \\&quot;foo\\&quot;)&quot;) {82, 1} iex&gt; Enum.member?([1, 2], &quot;foo&quot;) # first argument doesn&#39;t match false iex&gt; Enum.member?([1, 2, 3], &quot;bar&quot;) # second argument doesn&#39;t match false iex&gt; Enum.member?([1, 2, 3], &quot;foo&quot;) # will match false # 18:55:44 #PID&lt;0.150.0&gt; IEx.Evaluator.init/4 # Enum.member?([1, 2, 3], &quot;foo&quot;) iex&gt; Rexbug.stop() :stopped redbug done, local_done - 1 iex&gt; Tracing messages sent and received from a process iex&gt; s = self() #PID&lt;0.193.0&gt; iex&gt; proc = Process.spawn(fn -&gt; ...&gt; receive do ...&gt; anything -&gt; send(s, {:got, anything}) ...&gt; end ...&gt; end, []) iex&gt; Rexbug.start([:send, :receive], procs: [proc], time: 60_000) {1, 0} iex&gt; send(proc, :foo) :foo # 18:31:08 #PID&lt;0.208.0&gt; (:dead) # &lt;&lt;&lt; :foo # 18:31:08 #PID&lt;0.208.0&gt; (:dead) # #PID&lt;0.193.0&gt; IEx.Evaluator.init/4 &lt;&lt;&lt; {:got, :foo} iex&gt; flush() {:got, :foo} :ok redbug done, timeout - 2"},{"ref":"readme.html#motivation","title":"README - Motivation","type":"extras","doc":"I was discussing investigating some unexpected behaviour in an Elixir project with one of my colleagues and he rightfully suggested using a tracing debugger to get to the bottom of it. The tool he had the most experience with was :redbug and it soon turned out it&#39;s possible to use from iex and with Elixir code, as long as you know some Erlang and are mindful of some gotchas. I really liked how :redbug was designed, but wished using it with Elixir was more streamlined..."},{"ref":"readme.html#redbug-syntax-comparison","title":"README - :redbug syntax comparison","type":"extras","doc":"If you want to move between :redbug and Rexbug or you&#39;re just curious how they compare, here&#39;s some examples: # tracing an Erlang module Rexbug.start(&quot;:ets&quot;) :redbug.start(&#39;ets&#39;) # stopping Rexbug.stop() :redbug.stop() # tracing with arguments matching (and strings) Rexbug.start(&quot;String.starts_with?(_, \\&quot;foo\\&quot;)&quot;) # you can use the ~s sigil so that you don&#39;t have to escape the quotes :redbug.start(&#39;\\&#39;Elixir.String\\&#39;:\\&#39;starts_with?\\&#39;(_, &lt;&lt;&quot;foo&quot;&gt;&gt;)&#39;) # selecting the actions Rexbug.start(&quot;Map.new/_ :: return;stack&quot;) :redbug.start(&#39;\\&#39;Elixir.Map\\&#39;:new -&gt; return;stack&#39;)"},{"ref":"readme.html#known-issues-limitations","title":"README - Known issues/limitations","type":"extras","doc":"In the trace patterns &quot;Mod.fun&quot; implicitly translates to &quot;Mod.fun()&quot;, which is equivalent to &quot;Mod.fun/0&quot;. To target the function with any arity, use &quot;Mod.fun/_&quot; or &quot;Mod.fun/any&quot;"},{"ref":"readme.html#faq","title":"README - FAQ","type":"extras","doc":"My app is already running and it doesn&#39;t have Rexbug in its dependencies. Can I still debug it? Yes! You can connect to it from a node that has Rexbug in its path and work from there. The app: nietaki@shiny:~$ iex --sname production --cookie monster Erlang/OTP 20 [erts-9.0] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:10] [hipe] [kernel-poll:false] Interactive Elixir (1.4.5) - press Ctrl+C to exit (type h() ENTER for help) iex(production@shiny)1&gt; Rexbug.help() # the node doesn&#39;t know about Rexbug ** (UndefinedFunctionError) function Rexbug.help/0 is undefined (module Rexbug is not available) Rexbug.help() iex(production@shiny)2&gt; Stream.interval(1000) |&gt; Enum.each(&amp;Integer.mod(&amp;1, 3)) Your local shell: nietaki@shiny:~$ iex --sname investigator --cookie monster -pa ~/repos/rexbug/_build/dev/lib/rexbug/ebin/ -pa ~/repos/rexbug/_build/dev/lib/redbug/ebin/ Erlang/OTP 20 [erts-9.0] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:10] [hipe] [kernel-poll:false] Interactive Elixir (1.4.5) - press Ctrl+C to exit (type h() ENTER for help) iex(investigator@shiny)1&gt; opts = [target: :production@shiny, msgs: 4] [target: :production@shiny, msgs: 4] iex(investigator@shiny)2&gt; Rexbug.start(&quot;Integer.mod/2&quot;, opts) {63, 1} % 23:53:44 &lt;9548.89.0&gt;({&#39;Elixir.IEx.Evaluator&#39;,init,4}) % &#39;Elixir.Integer&#39;:mod(46, 3) % 23:53:45 &lt;9548.89.0&gt;({&#39;Elixir.IEx.Evaluator&#39;,init,4}) % &#39;Elixir.Integer&#39;:mod(47, 3) % 23:53:46 &lt;9548.89.0&gt;({&#39;Elixir.IEx.Evaluator&#39;,init,4}) % &#39;Elixir.Integer&#39;:mod(48, 3) % 23:53:47 &lt;9548.89.0&gt;({&#39;Elixir.IEx.Evaluator&#39;,init,4}) % &#39;Elixir.Integer&#39;:mod(49, 3) redbug done, msg_count - 4 iex(investigator@shiny)3&gt; Instead of pointing to the Rexbug and :redbug beam files you can just clone this repo and run iex -S mix in the root directory: nietaki@shiny:rexbug (master=)$ iex --sname investigator --cookie monster -S mix Erlang/OTP 19 [erts-8.3] [source] [64-bit] [smp:8:8] [async-threads:10] [hipe] [kernel-poll:false] Interactive Elixir (1.4.4) - press Ctrl+C to exit (type h() ENTER for help) iex(investigator@shiny)1&gt; opts = [target: :production@shiny, msgs: 4] [target: :production@shiny, msgs: 4] iex(investigator@shiny)2&gt; Rexbug.start(&quot;Integer.mod/2&quot;, opts) (...) How does Rexbug compare with other Elixir debuggers? Good question! There are other projects that give you similar capabilities, like dbg by @fishcakez or exrun, both of which look great and are definitely more battle-tested than Rexbug. I&#39;ll try to add a brief and unbiased (as much as I can) comparison after I&#39;ve spent some time playing with them so I can do make sure I know what I&#39;m talking about. Why &quot;translate&quot; the syntax instead of forking :redbug and caling its internals directly? There&#39;s a number of reasons: The performance overhead should be irrelevant. You pay the small additional cost once every time you run Rexbug.start/2 and it should be negligible compared to whatever system you&#39;re debugging. Since :redbug is included as-is you can still use it directly and benefit from any new features it might get. Also if your team is split between people more comfortable in Erlang and Elixir, everyone can use what they prefer. &quot;time to market&quot; - doing this was the simplest way I could think of to get to a relatively polished library. This approach didn&#39;t seem to limit the possible featureset. All the :redbug features can still be provided. In general there weren&#39;t enough reasons to do it the other way. I don&#39;t rule out the possibility of a future rewrite, which wouldn&#39;t be too drastic anyways."}]